unit BTStd;

interface

////////////////////////////////////////////////////////////////////////////////
//******************************************************************************
// Supported OS: Win9x, WinNT, Win2000, WinXP, WinVista
//******************************************************************************
uses Windows, SysUtils;   
//******************************************************************************
////////////////////////////////////////////////////////////////////////////////

//xy Error Codes -> working with BT classes

//xy Error Codes -> writing own BT Classes

//xy ranges of errors  (...how to expand this unit...)
// (TRANS) means that this errors can be translated from system errors

////////////////////////////////////////////////////////////////////////////////
// -> ERROR CHECK HELPER METHODS <-                                        Begin
//------------------------------------------------------------------------------
  { Methods for checking class errors }
  function BTSucceeded(f_ErrorCode: DWORD): Boolean;
  function BTFailed(f_ErrorCode: DWORD): Boolean;
  { Methods for checking systems (OS) errors }
  function SystemErrorToString(f_ErrCode: Cardinal): string;
//------------------------------------------------------------------------------
// -> EROOR CHECK HELPER METHODS <-                                          End
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// -> SUCCESS CODES <-                                                     Begin
//------------------------------------------------------------------------------
// Type definition: see ERROR CODES Type definition.
//------------------------------------------------------------------------------
const   BT_OK      =       ERROR_SUCCESS;  //  ...there is only one....
//------------------------------------------------------------------------------
// -> SUCCESS CODES <-                                                       End
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// -> ERROR CODES <-                                                       Begin
//------------------------------------------------------------------------------
{ Type definition: }  type TBTCommonError = type DWORD; const
//------------------------------------------------------------------------------

  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  // BT_ERROR_SYSTEM is a error which can have a lot of reasons,
  // calling GetErrorString immediately after the failed method call will
  // give you a more specified system error information string.
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  BT_ERROR_SYSTEM                               = $00000001;
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  // Common error codes
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  { can happen after a System Dialog call, when the user press Abort }
  BT_COMMON_ERROR_REQUEST_ABORTED               = $00000002;
  BT_COMMON_ERROR_NOT_IMPLEMENTED               = $0000002D;
  BT_COMMON_UNKNOWN_ERROR                       = $0000002E;
  BT_COMMON_ERROR_HANDLE                        = $0000002F;
  BT_COMMON_ERROR_NIL_POINTER                   = $00000070;
  BT_COMMON_ERROR_INVALID_PARAM                 = $00000071;
  BT_COMMON_ERROR_MYSQLCONNECT_FAILED           = $00000072;
  BT_COMMON_ERROR_MYSQL                         = $00000073;
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  // Registry Errors
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  BT_REG_ERROR_OBJECT_IS_NULL                   = $00000090;
  BT_REG_UNKNOWN_ERROR                          = $00000091;
  BT_REG_ERROR_OPENKEY                          = $00000092;
  BT_REG_ERROR_READ_KEY_VALUE                   = $00000093;
  BT_REG_ERROR_WRITE_KEY_VALUE                  = $00000094;
  BT_REG_ERROR_DELETE_KEY_VALUE                 = $00000095;
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  // File error codes
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  { an invalid podition have been set }
  BT_FILE_ERROR_INVALID_POSITION                = $00000003;
  { file is already open }
  BT_FILE_ERROR_FILE_IS_OPEN                    = $00000005;
  { file is not open }
  BT_FILE_ERROR_FILE_IS_NOT_OPEN                = $00000006;
  { selected file open mode is invalid }
  BT_FILE_ERROR_INVALID_FILE_OPEN_MODE          = $0000000F;
  { selected file open parameter is invalid }
  BT_FILE_ERROR_INVALID_FILE_OPEN_PARAM         = $00000010;
  { selected file share mode is invalid }
  BT_FILE_ERROR_INVALID_FILE_SHARE_MODE         = $00000011;
  { writing to file is not supported }
  BT_FILE_ERROR_FILE_WRITE_NOT_SUPPORTED        = $00000012;
  { reding from file is not supported }
  BT_FILE_ERROR_FILE_READ_NOT_SUPPORTED         = $00000013;
  // !! xy test the following errors-- !!
  { file to open do not exist }
  BT_FILE_ERROR_FILE_NOT_FOUND                  = $00000016;
  { file path do not exist }
  BT_FILE_ERROR_PATH_NOT_FOUND                  = $00000017;
  { The system cannot open the file }
  BT_FILE_ERROR_TOO_MANY_OPEN_FILES             = $00000018;
  { The media is write protected }
  BT_FILE_ERROR_WRITE_PROTECT                   = $00000019;
  { The process cannot access the
    file because it is being used
    by another process. }
  BT_FILE_ERROR_SHARING_VIOLATION               = $0000001A;
  { Too many files opened for sharing}
  BT_FILE_ERROR_SHARING_BUFFER_EXCEEDED         = $0000001B;
  { another process has locked a
    portion of the file }
  BT_FILE_ERROR_LOCK_VIOLATION                  = $0000001C;
  { The file already exists }
  BT_FILE_ERROR_FILE_ALREADY_EXISTS             = $00000020;
  { The system cannot open the device
    or file specified }
  BT_FILE_ERROR_OPEN_FAILED                     = $00000021;
  { The file name is too long }
  BT_FILE_ERROR_NAME_TOO_LONG                   = $00000022;
  { The disk is full. equal to:
    BT_FS_ERROR_DISK_FULL}
  BT_FILE_ERROR_HANDLE_DISK_FULL                = $00000023;
  { The disk is full. equal to:
    BT_FS_ERROR_HANDLE_DISK_FULL}
  BT_FILE_ERROR_DISK_FULL                        = $00000024;
  { No more internal file
    identifiers available. }
  BT_FILE_ERROR_NO_MORE_HANDLES                 = $00000025;
  { The filename, directory name,
    or volume label syntax
    is incorrect. }
  BT_FILE_ERROR_INVALID_NAME                    = $00000026;
  { Cannot create a file when
    that file already exists }
  BT_FILE_ERROR_ALREADY_EXISTS_ON_CREATE        = $00000027;
  { The filename or extension
    is too long }
  BT_FILE_ERROR_FILENAME_EXCED_RANGE            = $00000028;
  { The global filename characters,
    * or ?, are entered }
  BT_FILE_ERROR_META_EXPANSION                  = $00000029;
  { The file or directory is
    corrupt and non-readable. }
  BT_FILE_ERROR_FILE_CORRUPT                    = $0000002A;
  { The disk structure is corrupt
    and non-readable }
  BT_FILE_ERROR_DISK_CORRUPT                    = $0000002B;
  { Access is denied }
  BT_FILE_ERROR_ACCESS_DENIED                   = $0000002C;
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  // Nerwork error codes
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  { Network request is not supported }
  BT_NETWORK_ERROR_NETWORK_NOT_SUPPORTED        = $0000001D;
  { Network path was not found. }
  BT_NETWORK_ERROR_BAD_NETPATH                  = $0000001E;
  { Network is busy }
  BT_NETWORK_ERROR_NETWORK_BUSY                 = $0000001F;
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  // Server error codes
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  BT_SERVER_NOT_RUNNING                         = $0000002F;
  BT_SERVER_ALREADY_RUNNING                     = $00000030;
  BT_SERVER_STARTUPINFO_INVALID                 = $00000031;
  BT_SERVER_ALREADY_ADRESSPORT_IN_USE           = $00000032;
  BT_SERVER_WSASTARTUP_FAILED                   = $00000033;
  BT_SERVER_WSACLEANUP_FAILED                   = $00000034;
  BT_SERVER_RESOLVE_LOCALHOSTIP_FAILED          = $00000035;

  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  // PHP support
  //^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  BT_PHP_SYSTEM_LIBRARY_NOT_LOADED          = $00000076;
  BT_PHP_ENGINE_NOT_RUNNING                 = $00000077;


//------------------------------------------------------------------------------
// -> ERROR CODES <-                                                         End
////////////////////////////////////////////////////////////////////////////////

type
   TBTStdLog = class(TObject)
     public
       procedure ConsoleLogDbg(f_LogMsg: string);
   end;


implementation

function BTSucceeded(f_ErrorCode: DWORD): Boolean;
begin
  Result := True;
  if f_ErrorCode = BT_OK then
    exit;
  Result := False;
end;

function BTFailed(f_ErrorCode: DWORD): Boolean;
begin
  Result := True;
  if f_ErrorCode <> BT_OK then
    exit;
  Result := False;
end;

function SystemErrorToString(f_ErrCode: cardinal): string;
var
  err: array[0..512] of Char;
begin
  FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil, f_ErrCode, 0, @err, 512, nil);
  Result := string(err);
end;

procedure TBTStdLog.ConsoleLogDbg(f_LogMsg: string);
begin
  Writeln(DateTimeToStr(Now) + ' - ' + f_LogMsg);
end;

end.
